<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 ** Component: cases
 **
 ** WEB interface for opening studies
 **
 **  @param cGr           Study Instance UIDs of studies to be opened
 **  @param cBack         URL to go back after open
 **  @param cInstr        Operation: Open
 **  @param cKey_<study>  Temporary key to access source study when opening a shortcut
 **  @param cStudy        Study Instance UID of the highlighted study
 **                       in case of batch open from relevant page
 **
 ** $Date: 2014/04/16 17:50:20 $
 **
 *
 *  RCS File Name    : $RCSfile: oper.jsp,v $
 *  RCS Revision     : $Revision: 1.127 $
 *  Locked by        : $Locker:  $
 *  Symbolic name    : $Name:  $
 *  State             : $State: Exp $
-- %><%@page import="java.util.*"%>
<%@page import="java.sql.SQLException"%>
<%@page import="java.sql.ResultSet"%>
<%@
	page import="imagemed.dotcom.DotcomConfig,imagemed.layout.datasource.EntryLayoutFactory,
			  imagemed.util.*,imagemed.types.*,imagemed.types.number.*,imagemed.types.string.*,imagemed.exception.*,
			  imagemed.imsession.*,imagemed.jsputil.*,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			  imagemed.dcprocessing.StudyRemover"
%><%@
	page errorPage="../main/exceptionHandler.jsp"
	
%><%!static final String m_tabPage = "cases/index.jsp";

	/**
	 * Returns value for a field from an SQL result set.
	 * This method handles fields having multiple database fields (like DATE).
	 * 
	 * @param rs      SQL result set
	 * @param field   ID of the field
	 *
	 * @return field value
	 *
	 * @throws SQLException if an SQL error occurs
	 */
	public static String getDBValue( ResultSet rs, String field ) throws SQLException {
		String dbName = IMBaseFieldManagerImpl.staticGetDbName( field );
		StringTokenizer st = new StringTokenizer( dbName, "," );
		if ( st.countTokens() < 2 ) {
			return rs.getString( dbName );
		}

		StringBuffer value = new StringBuffer();
		while ( st.hasMoreTokens() ) {
			String v = rs.getString( st.nextToken() );
			if ( v == null ) {
				return value.length() == 0 ? null : value.substring( 1 );
			}

			value.append( "_" ).append( v );
		}

		return value.substring( 1 );
	}%><%-- Input Parameters -- %><%

	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}

	String[] parGrArray = request.getParameterValues( "cGr" );
	String parBack = request.getParameter( "cBack" );

	if ( null == parBack ) {
		parBack = request.getHeader( "Referer" );
	}
	if ( null == parBack ) {
		parBack = "javascript:self.history.back();";
	}

	if ( parGrArray == null ) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "GENERAL_BATCH_NO_STUDIES" ), "cases/index.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BATCH_ERROR_TITLE" ), parBack, 4 );
	}

	String parInstr = request.getParameter( "cInstr" );
	boolean isOpen = "Open".equals( parInstr );
	boolean isWvOpen = "WvOpen".equals( parInstr );

	if ( !( isOpen || isWvOpen ) ) {
		throw new IMGeneralException( "Invalid operation: " + parInstr, "cases/index.jsp", "BATCH_ERROR_TITLE", parBack, 4 );
	}

	if ( !is.hasRight( imagemed.types.flag.IMTypeur.OPEN_RIGHT ) ) {
		throw new IMGeneralException( "OPEN_NO_RIGHTS", "cases/index.jsp", "OPEN_ERROR_TITLE", parBack, 4 );
	}

	if ( isWvOpen ) {
		StringBuilder url = new StringBuilder();
		url.append( is.httpx_host + "/EPVWeb/EPVWeb.jsp?cBack=" + Helper.URLEncodeUTF8( parBack ) );
		if ( DotcomConfig.selfDevice().isDbOnly() ) {
			for ( String study : parGrArray ) {
				String redirHost = RedirectToolbox.getClosestRedirectForStudy( is, study );
				url.append( "&cStudyUrl=" + Helper.URLEncodeUTF8( redirHost + "/EPVWeb/epvweb/epv?cStudy=" + Helper.URLEncodeUTF8( study ) +
						"&ParentSession=" + is._sid + "&RefererHost=" + RedirectToolbox.getThisHostEnc( is ) ) );
			}
		}
		else {
			for ( String study : parGrArray ) {
				url.append( "&cStudyUrl=" + Helper.URLEncodeUTF8( is.httpx_host + "/EPVWeb/epvweb/epv?cStudy=" + Helper.URLEncodeUTF8( study ) +
						"&sessionid=" + is._sid ) );
			}
		}
		response.sendRedirect( url.toString() + "#studyview" );
		return;
	}
	else {
		//BugFix:#7458 - at RelevantBatchOpen the highLighted study must be first if linkGr contains the highLighted study
		String relevantStudy = is.request.getParameter( "cStudy" );
		if ( relevantStudy != null && 1 < parGrArray.length ) {
			Vector<String> studyList = new Vector<String>();
			studyList.addAll( Arrays.asList( parGrArray ) );
			if ( studyList.contains( relevantStudy ) && !relevantStudy.equals( parGrArray[ 0 ] ) ) {
				studyList.remove( relevantStudy );
				studyList.add( 0, relevantStudy );
				is.imRequest.setProperty( "cGr", studyList.toArray( new String[ studyList.size() ] ) );
			}
		}

		GetpbsToolbox getpbsToolbox = new GetpbsToolbox( is );

		getpbsToolbox.collectAndCheckStudiesToOpen();
		getpbsToolbox.sendResponse();
	}
	if ( true ) {
		return;
	}
%>--%>