<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%-- ----------------------
     showCoercionRules.jsp
     
     NOT USED! (online help instead)
     
     Show Coercion Rules
     
     Author: Gabor Ligeti <gligeti@imagemedical.com>
     Date:   2002/04/26
     ----------------------
-- %><%@page import="imagemed.jsputil.DicomToolbox"%>
<%@ page errorPage="../main/exceptionHandler.jsp"%>
<%@ page
	import="imagemed.util.*,imagemed.imsession.*,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl"
%>
<%
	IMSession is = new IMSession(request, response, out);
	if (!is.regOK()) {
		return;
	}

	
%>
<%@page import="java.io.File"%><%@page import="imagemed.layout.datasource.LayoutDescriptor"%>
<%@page import="imagemed.exception.IMException"%>

<HEAD>
<TITLE>Coercion Rules Syntax</TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
%>
</HEAD>
<BODY>
<TABLE width="100%" border=1 cellpadding=0 cellspacing=0 class=BgMedLight>
	<tr><td class=BgShadow>
		<br>&nbsp;&nbsp;<font size=4>Coercion Rules Syntax<br><br>
	</font></td></tr>
<%
	out.write( "<TR valign=\"top\"><TD>\n" );
	
	DicomToolbox.writeRules( is.out, "General Syntax", new String[][]{ { "comment lines", "Lines starting with '#' are treated as comments" }, { "<i>lvalue</i>=<i>expression</i>", "Expression can be either a <i>Value</i> or a <i>Function</i>." } } );
	
	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );
	
	DicomToolbox.writeRules( is.out, "lvalues", new String[][]{ { "<i>DICOM Tag</i>", "The tag value for DICOM defined attributes and eRAD PACS's pre-defined user fields, User1-10.<BR>This lvalue is in the form \"(gggg,eeee)\"." },
			{ "<i>User defined field</i>", "A custom configured user field, specifically, one that do not exist in the DICOM library.<BR>This lvalue is in the form \"USER(<i>fieldName</i>)\", where <i>fieldName</i> is the Field Name defined in the custom user fields configuration file." },
			{ "<i>Temporary Variable</i>", "A variable used to temporarily hold an evaluated expression. Temporary values are not stored in the object.<BR>This lvalue is in the form \"$(<i>varName</i>)\", where <i>varName</i> is the name of the variable." } } );
	
	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );
	
	DicomToolbox.writeRules( is.out, "Values", new String[][]{ { "(gggg,eeee)", "Returns the value of a DICOM tag. If the DICOM tag does not exist, NULL() is returned." },
			{ "USER(<i>fieldName</i>)", "Returns the value of a user defined field. If the field does not exist, NULL() is returned." },
			{ "$(<i>varName</i>)", "Returns the value of a temporary variable. If the variable is not set, NULL() is returned." },
			{ "Quoted string", "This is in the form, \"<i>string</i>\". Returns the literal string <i>string</i>.<BR>The string can contain escaped characters, including \"\\n\", \"\\\\\" and '\\\"'." },
			{ "Unquoted string", "Non-quoted strings can be used when they contain only contiguous, alphanumeric characters." }, { "(gggg,eeee),\"d\",n", "(Retired) This returns the nth field in the DICOM tag (gggg,eeee) value as separated by the delimiter <i>d</i>." },
			{ "<i>empty string</i>", "The empty string, \"\"." }, } );

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "Basic Functions", new String[][]{
			{ "NULL()", "Deletes the target lvalue." }, } );

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "Logical Functions", new String[][]{
			{ "and(a,b)", "Returns <i>true</i> if both <i>a</i> and <i>b</i> are non-NULL." },
			{ "equals(a,b)", "Returns <i>true</i> if <i>a</i> and <i>b</i> are equal, NULL if they are not equal" },
			{ "if(cond,a,b)", "Returns <i>a</i> if <i>cond</i> is not NULL, <i>b</i> if cond is NULL." },
			{ "not(a)", "Returns <i>true</i> if <i>a</i> is NULL, NULL if <i>a</i> is not NULL." },
			{ "or(a,b[,c...])", "Returns the first non-NULL value." }, } );

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "String Functions", new String[][]{
			{ "concat(a,b[,c...])", "Concatenates the values <i>a</i> and <i>b</i> (and <i>c</i>, etc.) NULL values are treated as an empty string, \"\"." },
			{ "contains(a,b)", "Returns <i>b</i> if <i>b</i> is found in <i>a</i>, NULL otherwise." },
			{ "indexof(a, ss)", "Returns the starting position of <i>ss</i> in <i>a</i>, or -1 if not contained." },
			{ "split(a,d,n)", "Returns the <i>n</i>th field in <i>a</i> using <i>d</i> as the field delimiter." },
			{ "strlen(s)", "Returns the length of <i>s</i>, or NULL if <i>s</i> is NULL." },
			{ "substr(s, p [,n])", "Returns the given section of the <i>s</i> starting from the position <i>p</i><BR>(0 based, 0 means the beginning of the string), in the length specified by <i>n</i>." }, } );

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "Date Functions", new String[][] {
	{ "dicomAge(d1, d2)", "Returns the value <i>d1</i> - <i>d2</i> in calendar years, months or days in<BR>DICOM-compliant format: <i>nnn</i>Y, <i>nnn</i>M, or <i>nnn</i>D.<BR>If either <i>d1</i> or <i>d2</i> is an invalid date value, or <i>d2</i> predates <i>d1</i>, NULL is returned." }
	}	);

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "Arithmetic Functions", new String[][]{
			{ "add(n,m[,o...])", "Returns the sum of the parameter integer strings." },
			{ "sub(n,m)", "Returns <i>n</i> - <i>m</i>, where <i>n</i> and <i>m</i> must be integer strings." },
			{ "between(v,n,m)", "Returns <i>true</i> if <i>v</i> is greater than or equal to <i>n</i> and <i>v</i> is less than <i>m</i>, NULL otherwise. <BR><i>v</i>, <i>n</i> and <i>m</i> are integer strings." },
			} );

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "Encoding Functions", new String[][]{
			{ "codenumber(n)", "<i>n</i> must be a >= 0 integer string, returns a coded >= 0 integer string with the same number of digits." },
			{ "codestring(s[,exc])", "<i>s</i> is a string, returns a coded string with the same length. If <i>exc</i> is used, the result will not include these characters." }, } );

	out.write( "</TD></TR><TR valign=\"top\"><TD>\n" );

	DicomToolbox.writeRules( is.out, "Misc Functions", new String[][]{
			{ "rnd(n[,seed])", "Returns a random number (integer string) between 0 and <i>n-1</i>. If <i>seed</i> is used, the random number will be calculated from it." }, } );

	out.write( "</TD></TR>\n" );

%>
	</TD>
	
</TABLE>	
</BODY>
--%>