<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *   Send report to RIS in HL7 messages
 *
 * Parameters:
 *
 *  @param cStudy         Instance UID of the study to send reports for
 *  @param cOp            operation ('send' for sending, any other results in a confirmation page)
 *  @param cBack          Back URL 
 *
 * Last Updated     : $Author: tnemeth $
 * Update Date Time : $Date: 2014/04/17 10:22:18 $
 * RCS File Name    : $RCSfile: sendOrder.jsp,v $
 * RCS Revision     : $Revision: 1.4 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
-- %><%@
	page import="java.text.*, java.sql.*, java.util.*, imagemed.exception.*, imagemed.imsession.*,
			imagemed.types.*, imagemed.types.string.*, imagemed.types.date.*, imagemed.types.flag.*,
			imagemed.jsputil.*, imagemed.util.*"

%><%@
	page errorPage="/main/exceptionHandler.jsp"

%><%!
	static String m_tab = "cases/index.jsp";

%><%IMSession is = new IMSession( request, response, out );

is.response.setHeader( "pragma", "no-cache" );
is.response.setHeader( "Cache-Control", "no-cache, must-revalidate" );
is.response.setHeader( "Expiry-Date", "Friday, 31-Dec-70 23:59:59 GMT" );

String back = request.getParameter( "cBack" );
if ( back == null )
	back = request.getHeader( "REFERER" );

is.regDest = back;
if ( !is.regOK() )
	return;

if ( !is.hasRight( PacsRight.Support.letterString() ) && !is.hasRight( PacsRight.Admin.letterString() ) ) { // neither Support nor Admin right
	Format[] msgFormat = new Format[] { null };
	Object[] msgObject = new Object[] { is.regID };
	throw new IMGeneralException( is,
			LocalizedMessage.getCompoundMessage( "NO_RIGHTS_REQ_PAGE", msgFormat, msgObject, true),
			m_tab, LocalizedMessage.getSimpleMessage( "SEND_ORDER_ERROR_TITLE" ), back, 4 );
}

String study = request.getParameter( "cStudy" );
String oper = request.getParameter( "cOp" );

if ( study == null ) {
	throw new IMGeneralException( is,
			LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ),
			m_tab, LocalizedMessage.getSimpleMessage( "SEND_ORDER_ERROR_TITLE" ), back, 4 );
}

ResultSet rs = IMEnv.getDB().prepareStatement( "SELECT PNAME, THEDATETIME, MODALITY, MAINST, SRCSTUDY from " + IMEnvBase.getEnv( "STUDYTBL" ) + " where STYIUID='" + study + "'" ).executeQuery();
if ( !rs.next() ) {
	rs.close();
	throw new IMGeneralException( is,
			LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_NO_SUCH_STUDY" ),
			m_tab, LocalizedMessage.getSimpleMessage( "SEND_ORDER_ERROR_TITLE" ), back, 4 );
}

String sourceStudy = rs.getString( "SRCSTUDY" );
String patientName = IMTypePN.displayOrdinaryText( rs.getString( "PNAME" ) );
String studyDate = ((IMTypeDt) IMType.getTypeFor( "Dt" )).displayDateOnly( rs.getString( "THEDATETIME" ) );
String modality = rs.getString( "MODALITY" );
rs.close();

if ( sourceStudy == null ) {
	sourceStudy = StudyToolbox.getSourceStudyDB( study );
}

// Confirmation page has been temporarily turned off.
// It may re-appear if selecting target device is implemented
oper = "send";

if ( "send".equals( oper ) ) {
	String msgName = "SEND_ORDER_ERROR_MSG";
	String fontCl = " class=\"FontError\"";
	
	try {
		StudyToolbox.rmiSendOrderToRIS( null, study );
		msgName = "SEND_ORDER_STARTED";
		fontCl = "";
	}
	catch ( Throwable th ) {
		Helper.ERRORLOG( "SendOrderToRIS", Helper.throwable2String( th ) );
	}

	String msg = LocalizedMessage.getSimpleMessage( msgName );
	
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "SEND_ORDER_PAGE_TITLE" ), "60%" );
	mb.setMessage( "<DIV style=\"padding: 5px;\"" + fontCl + ">" + msg + "</DIV>" );
	
	throw new IMMessageBoxException( is, mb, "cases/index.jsp", 4, back );
}

// DEAD - need to be updated for order messages when re-eanbled (if ever)

String titleInfo = patientName + " - " + studyDate + " - " + modality;
String title = LocalizedMessage.getCompoundMessage( "SEND_REPORT_OF", new Format[] { null }, new Object[] { titleInfo }, true );%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "SEND_ORDER_PAGE_TITLE" ) %></TITLE>
<%
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( is );
%>

<STYLE type="text/css">
		 TABLE.mbox {
		 	margin-left: auto;
			margin-right: auto;
			margin-top: 10px;
		 }
</STYLE>

</HEAD>
<BODY>
<%
	TabToolbox.makeTabs(is, is.tabbean, "cases/index.jsp", "White");
%>
<TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
	<TR><TD class=BgShadow width="100%">
		<TABLE border=0 cellpadding=0 cellspacing=0 width="100%" align=left><TR>
 			<TD nowrap class=BgShadow style="padding: 15px 20px;">
				<font size=4><%= title %></font>
			</TD>
			<TD class=BgShadow nowrap width="20%" align=right>
				<a style="margin-left: 30px; margin-right: 30px;" href="<%=back%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_BACK", "BUTTON_NULL", false ) %></a>
			</TD>
		</TR></TABLE>
	</TD></TR>
</TABLE>
<%



Vector<String> hl7Devs = new Vector<String>();
rs = IMEnv.getDB().prepareStatement( "select ID from " + IMEnvBase.getEnv( "DEVSERVTBL" ) +
		"," + IMEnvBase.getEnv( "TARGETTBL" ) + " where Service='RepU' and DEVICE=ID" ).executeQuery();
while ( rs.next() ) {
	String id = rs.getString( "ID" );
	if ( id != null ) {
		hl7Devs.add( id );
	}
}
rs.close();

if ( hl7Devs.isEmpty() ) {
	throw new IMGeneralException( is,
			LocalizedMessage.getSimpleMessage( "SEND_REPORT_NOHL7" ),
			m_tab, LocalizedMessage.getSimpleMessage( "SEND_REPORT_ERROR_TITLE" ), back, 4 );
}

%>
<FORM name="confirmForm" action="sendReport.jsp" method="POST" style="display: inline;">
<INPUT type="hidden" name="cStudy" value="<%=Helper.htmlEncode( study ) %>" />
<INPUT type="hidden" name="cBack" value="<%=Helper.htmlEncode( back ) %>" />
<INPUT type="hidden" name="cOp" value="send" />
</FORM>
<DIV style="text-align: center;">
<%

String msg = LocalizedMessage.getSimpleMessage( "SEND_REPORT_TO_CONFIGURED" );
String altSendReport = LocalizedMessage.getSimpleMessage( "SEND_REPORT_ALT_TEXT" );

MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "SEND_REPORT_PAGE_TITLE" ), "50%", null, "mbox" );
// MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "SEND_REPORT_PAGE_TITLE" ), "50%" );
mb.setMessage( "<DIV style=\"padding: 5px;\">" + msg + "</DIV>" );

mb.addButton( new GraphicalButton( is, "javascript:self.document.confirmForm.submit();", "SendReport.png", altSendReport, 24, 24 ) );

mb.print( is.out );

%>
</DIV>
</BODY></HTML>--%>