<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%@page import="imagemed.http.Range"%><%@page import="imagemed.jsputil.RedirectToolbox"%><%--
 * Component: dotcom
 *
 * Description:
 *     Get objects to be kept when cleaning up studies reside on multiple HUB servers.
 *     Objects will be packed up to a tar.gz file
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@
	page import="java.io.*, java.util.*, java.sql.*, imagemed.dotcom.*, imagemed.imsession.*, imagemed.util.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

	static String m_env[] = new String[] { "HOME=" + IMEnvBase.getEnv("HOME") };

	static Syslog m_operLogger = new Syslog("cmh_getobjects", 0, IMEnvBase.getEnv("LOG_OPER_FACILITY"));

%><%

	IMSession is = new IMSession(request, response, out);

	response.setContentType("text/plain");

	Helper.DEBUG( "getObjects called" );

	/*
	try {
		Properties prpPeer = imagemed.jsputil.DotcomToolbox.checkClient(is, null, false);
		if (prpPeer != null) {
			String deviceID = prpPeer.getProperty("ID","");
			if ("".equals(deviceID)) {
				throw new Throwable();
			}
		}
	}
	catch (Throwable th) {
		out.println("#ERROR: Unauthorized peer");
		return;
	}
	*/

	String parStudy = request.getParameter( "cStudy" );
	String parSession = request.getParameter( "cSession" );
	String parUser = request.getParameter( "cUser" );
	String parTarget = request.getParameter( "cTarget" );
	String parExcept[] = request.getParameterValues( "cExcept" );
	boolean addReports = "true".equals( request.getParameter( "cReport" ) );
	boolean addImages = "true".equals( request.getParameter( "cImages" ) );
	boolean addShortcuts = "true".equals( request.getParameter( "cShortcuts" ) );
	String parEndDevice = request.getParameter( "cEndDevice" );

	if (parStudy == null) {
		out.println("#ERROR: Missing parameter: cStudy");
		return;
	}

	
	//redirect if needed
	if( DotcomConfig.selfDevice().isDbOnly() && parEndDevice != null && !"".equals( parEndDevice ) ) {
		String redirURL = RedirectToolbox.getURL( DotcomConfig.getConfig().getServerNameTowards( parEndDevice ), is.regIP, null );
		if( redirURL != null ) {
			redirURL += "/dotcom/getObjects.jsp?" + request.getQueryString();
			Helper.DEBUG( "getObjects redirect: " + redirURL );
			response.sendRedirect(redirURL);
			return;
		}
	}

	if (parSession == null) {
		parSession = "" + System.currentTimeMillis() + "." + Helper.getCounter();
	}

	String dbName = null;
	String dbModality = null;
	try {
		ResultSet rs = IMEnv.getDB().createStatement().executeQuery("select * from "+IMEnvBase.getEnv("STUDYTBL")+" where STYIUID='"+parStudy+"'");
		if (rs.first()) {
			dbName = rs.getString("PNAME");
			dbModality = rs.getString("MODALITY");
		}
	}
	catch (SQLException e) {
		Helper.DEBUG("dotcom.getObjects", Helper.throwable2String(e));
	}

	Set<String> exceptFiles = new TreeSet<String>();
	if (null != parExcept) {
		exceptFiles.addAll(Arrays.asList(parExcept));
	}

	StringBuffer msg = new StringBuffer();
	msg.append("move ");
	if (addImages) {
		msg.append("images");
		if (exceptFiles.size() > 0)
			msg.append(" [except: " + exceptFiles.size() + "]");
	}

	if (addReports) {
		if (addImages)
			msg.append(" and ");
		msg.append("report(s)");
	}

	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "cmhmove" );
	logEntry.setField( OperLogEntry.FIELD.USER, parUser );
	logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );
	logEntry.setField( OperLogEntry.FIELD.PNAME, dbName );
	logEntry.setField( OperLogEntry.FIELD.MODALITY, dbModality );
	logEntry.setField( OperLogEntry.FIELD.HOST, parTarget );
	logEntry.setField( OperLogEntry.FIELD.MESSAGE, msg.toString() );
	logEntry.log( m_operLogger, Syslog.LOG_INFO );

//	m_operLogger.syslog(Syslog.LOG_INFO, "INFO STUDY cmhmove "+ logUser+" - "+parStudy+" "+dbName+" "+dbModality+" "+ logTarget +" - - - - - - " + logMessage);

	String studyDir = RepositoryHandler.getLocation(RepositoryHandler.DATA, parStudy);
	String tarFile = IMEnvBase.getEnv("TMP") + "/multihub." + parSession + ".tar.gz";
	String lsFile = IMEnvBase.getEnv("TMP") + "/multihub." + parSession + ".ls";
	StringBuffer tarContent = new StringBuffer( 256 );
	tarContent.append( "chmStudyDir=\"" ).append( studyDir ). append( "\"\n" );

	String[] dataFiles = Helper.getDirectoryContentAsStringArray( studyDir );
	if (dataFiles == null) {
		out.println("#ERROR: Error listing study directory");
		return;
	}

	Set<String> fileSet = new TreeSet<String>();

	logEntry.setLevel( OperLogEntry.LEVEL.OBJECT );
	logEntry.setField( OperLogEntry.FIELD.MESSAGE, "" );

	FileWriter fw = new FileWriter(lsFile);
	for (int i = 0; i < dataFiles.length; i++) {
		if (dataFiles[i].startsWith(".")) {
			// Skip hidden files
			continue;
		}

		fw.write(dataFiles[i]);
		fw.write("\n");

		if (exceptFiles.contains(dataFiles[i])) {
			continue;
		}

		if (dataFiles[i].startsWith("SRt.") || dataFiles[i].startsWith("PbD.")) {
			if (!addReports) {
				// Do not include report files to the tar file
				continue;
			}
		}
		else if (!addImages) {
			// Do not include image files to the tar file
			continue;
		}

		logEntry.setField( OperLogEntry.FIELD.FNAME, dataFiles[i] );
		logEntry.log( m_operLogger, Syslog.LOG_INFO );

//		m_operLogger.syslog(Syslog.LOG_INFO, "INFO OBJECT cmhmove "+ logUser+" " + dataFiles[i] + " "+parStudy+" "+dbName+" "+dbModality+" "+ logTarget +" - - - - - - -");

		fileSet.add( studyDir + "/" + dataFiles[ i ] );
	}
	fw.close();

	if ( addShortcuts ) {
		int cntShortcuts = 0;
		ResultSet rsShortcuts = IMEnv.getDB().createStatement().executeQuery( "select STYIUID, FOLDER from " + IMEnvBase.getEnv( "STUDYTBL" ) + " where SRCSTUDY='" + parStudy + "' AND STYIUID!=SRCSTUDY" );
		while ( rsShortcuts.next() ) {
			String prefix = "chmShortcut" + cntShortcuts;
			String shortcutDir = RepositoryHandler.getLocation( RepositoryHandler.DATA, rsShortcuts.getString( "STYIUID" ) );
			fileSet.add( shortcutDir );
			tarContent.append( prefix ).append( "_DIR=\"" ).append( shortcutDir ). append( "\"\n" );
			tarContent.append( prefix ).append( "_FOLDER=\"" ).append( rsShortcuts.getString( "FOLDER" ) ). append( "\"\n" );
			cntShortcuts++;
		}
		rsShortcuts.close();
		tarContent.append( "chmNumShortcuts=\"" ).append( cntShortcuts ). append( "\"\n" );
	}
	
	File tempDir = new File( IMEnvBase.getEnv( "TMP" ) + "/chmtar." + parSession );
	if ( ! tempDir.mkdir() ) {
		out.println( "#ERROR: temporary directory could not be created" );
		
		logEntry.setLevel( OperLogEntry.LEVEL.STUDY );
		logEntry.setField( OperLogEntry.FIELD.FNAME, "" );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, "Temporary directory could not be created" );
		logEntry.log( m_operLogger, Syslog.LOG_ERR );

//		m_operLogger.syslog(Syslog.LOG_ERR, "ERROR STUDY cmhmove "+ logUser+" - "+parStudy+" "+dbName+" "+dbModality+" "+ logTarget +" - - - - - - " + logErrMessage);
		return;
	}

	File contentFile = new File ( tempDir, "CONTENT" );
	Helper.writeTextFile( contentFile.getAbsolutePath(), tarContent.toString() );
	Vector<String> cmd = new Vector<String>();

	cmd.add( "tar" );
	cmd.add( "czf" );
	cmd.add( tarFile );
	cmd.add( "-C" );
	cmd.add( tempDir.getAbsolutePath() );
	cmd.addAll( fileSet );
	cmd.add( "CONTENT" );

	RunCommandResult res = Helper.runCommandEx(cmd.toArray(new String[0]), m_env);
	if (res.getExitCode() != 0) {
		out.println("#ERROR: tar returned error " + res.getExitCode() + "\n" + res.getError());
		
		logEntry.setLevel( OperLogEntry.LEVEL.STUDY );
		logEntry.setField( OperLogEntry.FIELD.FNAME, "" );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, "An error occured while moving the images" );
		logEntry.log( m_operLogger, Syslog.LOG_ERR );

//		m_operLogger.syslog(Syslog.LOG_ERR, "ERROR STUDY cmhmove "+ logUser+" - "+parStudy+" "+dbName+" "+dbModality+" "+ logTarget +" - - - - - - " + logErrMessage);
		return;
	}

	Range range = new Range( request, response );
	range.sendRequestedRange( tarFile );

	/*
	InputStreamReader reader = new InputStreamReader( new FileInputStream(tarFile), "ISO-8859-1" );
	char buffer[] = new char[8092];
	int nRead = 0;
	while (0 < (nRead = reader.read(buffer))) {
		out.write(buffer, 0, nRead);
	}
	reader.close();
	*/
	
	%><%-- TODO: remove tar file if no longer needed-- %><%
	
	if (true) {
		// For avoiding extra new lines to be printed
		return;
	}
%>
--%>