<%--
 * Component: dotcom
 *
 * Description:
 *
 * Parameters:
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.toolbox.ClassesKeystoreParam"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.Envelope"%>
<%@page import="com.erad.pacs.toolbox.LoginServiceToolbox"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.expression.IMExpressionContext"%>
<%@
	page import="java.util.*, java.sql.ResultSet, java.math.BigInteger,
			imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			com.erad.pacs.toolbox.LogToolbox,
			imagemed.scheduler.SchedulerInterface"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

  static Syslog operLogger = new Syslog( "logtime.jsp", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );

%><%
	try {
		if ( DotcomToolbox.checkIPAddress( request.getRemoteAddr(), "P") == null ) {
			out.println( "#RESULT: FAILED - login" );
			return;
		}
	}
	catch (Throwable th) {
		out.println( "#RESULT: FAILED - login" );
		return;
	}
	String time = request.getParameter( "cTime" );
	Helper.DEBUG( "logtime.jsp", "time:" + time );
	String parentHost = "";
	try {
		parentHost = DotcomToolbox.getParentID();
	}
	catch ( Throwable th ) {
	}

	GregorianCalendar calMother = Helper.getCalendarFromDate( time );
	BigInteger secondsMother = IMExpressionContext.getSecondsFromCalendar( calMother );

	GregorianCalendar calMe = new GregorianCalendar();
	BigInteger secondsMe = IMExpressionContext.getSecondsFromCalendar( calMe );

	int corrigSeconds = secondsMe.subtract( secondsMother ).intValue();
	
	try {
		String timediffDbName = IMBaseFieldManagerImpl.staticGetDbName( "0LTD" ); 
		ResultSet rs = IMEnv.getDB().createStatement().executeQuery( "select " + timediffDbName +
			" from " + IMEnvBase.getEnv( "SCHEDULERLOGTBL" ) + " where " +
			IMBaseFieldManagerImpl.staticGetDbName("0LAC") + "='timestamp' order by concat(LOGEVENTDATE,LOGEVENTTIME) DESC LIMIT 1" );
		if ( rs.next() ) {
			String lastSecondsStr = rs.getString( timediffDbName );
			if ( lastSecondsStr != null ) {
				int lastSeconds = Integer.parseInt( lastSecondsStr );
				if ( Math.abs( corrigSeconds - lastSeconds ) <= LogToolbox.TIME_LOGGING_EPSILON_SECONDS ) {
					Helper.DEBUG( "Timestamp wasn't logged because diff is less then epsilon" );
					return;
				}
			}
		}
	}
	catch ( Throwable th ) {
		Helper.ERRORLOG( "Exception:" + Helper.throwable2String( th ) );
	}

	Session clientSession = null;
	try {
		UserManagerFacade um = Connector.getInstance().get( UserManagerFacade.Caller );
		Envelope envelope = LoginServiceToolbox.loginService( um, new ClassesKeystoreParam(), null );
		clientSession = um.checkEnvelope( request, response, envelope );
	}
	catch ( Throwable th ) {
		Helper.ERRORLOG( "Exception:" + Helper.throwable2String( th ) );
	}

	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.TIMESTAMP, "timestamp" );
	logEntry.setField( OperLogEntry.FIELD.USER, "system" );
	logEntry.setField( OperLogEntry.FIELD.TIMESTAMP_DIFFSECONDS, "" + corrigSeconds );
	logEntry.setField( OperLogEntry.FIELD.TIMESTAMP_PARENT, parentHost );
	logEntry.log( clientSession, operLogger, Syslog.LOG_INFO );

//	operLogger.syslog( Syslog.LOG_INFO, "INFO TIMESTAMP timestamp system " + corrigSeconds + " " + parentHost );%>