#!/bin/sh
#
# usage: printPdf.sh PDF [params_for_lp]
#

. ~/etc/setenv.sh

PDF=$1
shift

if [ "$PDF" == "" ]; then
	echo "The first parameter should contain the pdf file to be printed."
	return 1
fi

#$IMAGEMAGICK_HOME/bin/convert $PDF /tmp/printrep.$$.ps

/usr/bin/gs -sDEVICE=pswrite -q -dNOPAUSE -dSAFER -sOutputFile="/tmp/printrep.$$.ps" -- "$PDF" -c quit

/usr/bin/lp $@ /tmp/printrep.$$.ps

rm /tmp/printrep.$$.ps
